const $http = (url, data, type, loadingType) => {
  var app = getApp()
  // 判断token是否有或者过期
  //轮询接口专用判断
  // if(loadingType != 'NO'){
  //   dd.showLoading({
  //     content: '加载中...'
  //   });
  // }
  let hasToken = dd.getStorageSync({ key: 'token' }).data; // token
  let expires_in = hasToken.expires_in || ''; // 过期时效
  let loginTime = hasToken.expires_in || ''; // 用户登陆时间
  let token = hasToken.access_token || '';
  if(!!hasToken && ((new Date()).getTime() - hasToken.loginTime < hasToken.expires_in * 1000)){
    data.orgId = dd.corpId;
    let sendData = '';
    for(let key in data){
      sendData = `${sendData}${key}=${data[key]}&`
    }
    sendData = sendData.substring(0, sendData.length - 1);
    console.log(sendData);
    return new Promise((resolve, reject) => {
      dd.httpRequest({
        headers: {
          "Content-Type": "application/json",
          "Authorization": `Bearer ${token}`
        },
        url: `http://${app.globalData.globalUrl}/v1/${url}?${sendData}`,
        method: type,
        dataType: 'json',
        success: function(res) {
          if(res.data.resultCode === "0") {
            return resolve(res.data.data)
          } else {
            dd.alert({
              content: '系统繁忙',
              buttonText: '确定'
            });
          }
        },
        fail: function(res) {
          dd.hideLoading();
          dd.alert({
            content: '系统繁忙',
              buttonText: '确定'
          });
        }
      })
    })
  } else {
    dd.getNetworkType({
      success: (res) => {
        if (res.networkAvailable) {
          dd.getAuthCode({
            success:function(resultCode){
              dd.httpRequest({
                headers: {"Content-Type": "application/json"},
                url: `http://${app.globalUrl}/v1/auth/token?version=v1&code=${resultCode.authCode}&orgId=${dd.corpId}`,
                method: 'POST',
                dataType: 'json',
                success: function(res) {
                  // 全局存储用户信息token和用户信息
                  const data = res.data.data
                  // 更新用户内部信息
                  dd.setStorageSync({
                    key: 'token',
                    data: {
                      access_token: data.accessToken.access_token,
                      token_type: data.accessToken.token_type,
                      expires_in: data.accessToken.expires_in,
                      loginTime: (new Date()).getTime()
                    }
                  });
                  dd.setStorageSync({
                    key: 'userId',
                    data: data.oapiUser.userid
                  });
                  $http(url, data, type)
                },
                fail: function(res) {
                  console.log(res)
                }
              });
            },
            fail:function(err){
              dd.alert({
                content: '系统繁忙',
                buttonText: '确定'
              });
            }
          });
        } else {
          dd.alert({
            content: '登录超时，请连接网络重新登录',
            buttonText: '确定'
          });
        }
      }
    });
  }
}
export default {$http}